SystemOrganization addCategory: #'GT-InspectorExtensions-CoreRoassal'!

!CPDiverging methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 4/25/2014 15:16'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 40>
	composite roassal2
		title: 'View';
		painting: [ :view | self viewOn: view ]! !

!MessageTally methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 1/18/2014 21:36'!
gtInspectorPerformanceChartIn: composite
	<gtInspectorPresentationOrder: 40>
	| metric |
	metric := #localTally.
	^ composite graphET
		title: 'Top tallies';
		diagram: [ :renderer :presentation |
			GTInspectorMessageTallyCharter new 
				performanceOf: self 
				with: renderer 
				in: presentation ];
		when: [ self children notEmpty ]! !

!RTMondrianViewBuilder methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 4/18/2014 22:43'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]! !

!ROMondrianViewBuilder methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 12/17/2013 19:30'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: 30>
	composite roassal 
		title: 'View';
		view: self! !

!RTView methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AlexandreBergel 3/31/2014 14:24'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]
		! !

!GLMCompositePresentation methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 12/17/2013 16:18'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ composite roassal 
		title: 'Tree';
		painting: [:view :b | 
			self viewTreeOn: view ]! !

GLMCompositePresentation subclass: #GTInspectorMessageTallyCharter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-CoreRoassal'!

!GTInspectorMessageTallyCharter commentStamp: 'TudorGirba 1/18/2014 14:28' prior: 0!
Helper class for displaying charts specific for a MessageTally.!

!GTInspectorMessageTallyCharter methodsFor: 'visualization' stamp: 'TudorGirba 1/18/2014 14:30'!
nestingMapOf: aMessageTally on: view
	"This is provides a treemap visualization of a message tally"
		
	| builder methods methodNestings |
	builder := ROTreeMapBuilder new.
	builder weightBlock: [ :el | el children size max: 1 ].
	methods := OrderedCollection new.
	methodNestings := OrderedCollection new.
	aMessageTally 
		deep: #children
		do: [ :each | methods add: each ]
		relationDo: [ :from :to | methodNestings add: from->to ].
	builder nodes: methods.
	builder nestingFromAssociations: methodNestings.
	builder fillNodes: [:x | true] withColor: (RONColorLinearNormalizer inContext: methods withCommand: [:m | (m isKindOf: ROElement) ifTrue: [ m model localTally ] ifFalse: [m localTally] ]  lowColor: Color white highColor: Color red ).
	builder withShadedFrames.
	builder drawOn: view raw! !

!GTInspectorMessageTallyCharter methodsFor: 'visualization' stamp: 'TudorGirba 1/18/2014 22:30'!
performanceOf: aMessageTally with: renderer in: presentation
	"Displays a Graph-ET chart showing the top 20 most costly methods within a MessageTally.
	For each method it sows the number of occurences of a method and the 
	total amount of local tallies for that method. Useful for identifying outliers 
	within one execution."
	
	| all diag diag2 grouped metric |
	metric := #localTally.
	all := aMessageTally deepCollect: [ :each | each sonsOver: 1 ].
	grouped := (all groupedBy: [ :each | String streamContents: [:s | each gtDisplayIdentifierOn: s] ]) 
						associations sorted: [:a :b | 
									(a value sumNumbers: metric) > 
									(b value sumNumbers: metric) ].
	grouped := (grouped first: (20 min: grouped size)) select: [:each | (each value sumNumbers: metric) > 0].
	diag := (GETHorizontalBarDiagram new)
		xAxisLabel: 'Locations';
		modelLabels: [:each | each key ];
		x: [:each | each value size];
		valueAxis;
		color: Color veryLightGray;
		axisColor: Color veryLightGray;
		on: ROMouseClick do: [:event | presentation selection: event model value ];
		models: grouped.
	diag2 := (GETHorizontalBarDiagram new)
		xAxisLabel: 'Tallies';
		x: [:each | each value sumNumbers: metric];
		regularAxis;
		xAxisOnTop;
		gapFraction: 1 / 2;
		color: (Color red);
		axisColor: (Color red);
		on: ROMouseClick do: [:event | presentation selection: event model value ];
		models: grouped.
	(renderer unionDiagram)
		add: diag;
		add: diag2! !

!CPSequential methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 4/25/2014 15:16'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 40>
	composite roassal2
		title: 'View';
		painting: [ :view | self viewOn: view ]! !

!RTAbstractExample methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AlexandreBergel 8/18/2014 17:33'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 4>
	composite roassal2
		title: 'Example';
		painting: [ :view | self openOn: view ]! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 12/18/2013 05:26'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ composite roassal 
		title: 'Tree';
		painting: [:view :b | 
			self viewTreeOn: view ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 6/22/2014 20:52'!
gtInspectorGroupedFilesIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite graphET
		title: 'Grouped files';
		diagram: [ :renderer :presentation |
			| metric all grouped diag diag2|
			metric := #size.
			all := self allFiles.
			grouped := (all groupedBy: [ :each | each extension ]) 
								associations sorted: [:a :b | 
											(a value sumNumbers: metric) > 
											(b value sumNumbers: metric) ].
			grouped := (grouped first: (20 min: grouped size)) select: [:each | (each value sumNumbers: metric) > 0].
			diag := (GETHorizontalBarDiagram new)
				xAxisLabel: 'Number of files';
				modelLabels: [:each | each key ];
				x: [:each | each value size];
				valueAxis;
				color: Color veryLightGray;
				axisColor: Color veryLightGray;
				on: ROMouseClick do: [:event | presentation selection: event model value ];
				models: grouped.
			diag2 := (GETHorizontalBarDiagram new)
				xAxisLabel: 'Total size in MB';
				x: [:each | (each value sumNumbers: metric) / 1000000];
				regularAxis;
				xAxisOnTop;
				gapFraction: 1 / 2;
				color: (Color red);
				axisColor: (Color red);
				on: ROMouseClick do: [:event | presentation selection: event model value ];
				models: grouped.
			(renderer unionDiagram)
				add: diag;
				add: diag2 ];
				when: [self isDirectory and: [self hasChildren]]! !

!ROView methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 12/17/2013 20:34'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: 30>
	composite roassal 
		title: 'View';
		initializeView: [self]! !

!RTGraphBuilder methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 4/21/2014 21:33'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]! !

!CPQualitative methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 4/25/2014 15:16'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 40>
	composite roassal2
		title: 'View';
		painting: [ :view | self viewOn: view ]! !
